from email import message
import json

from tornado.web import RequestHandler
from agent.domain import DOMAINOBJ, loadDoamin


class BackupHandler(RequestHandler):
    def _backImpl(self, param_domain_dict:dict):
        """ Call the backup() function of each parameter domain in turn
        """
        global DOMAINOBJ
        domain_result = {}
        for domain, param_list in param_domain_dict.items():
            try:
                loadDoamin(domain)
            except Exception as _:
                continue
            else:
                avaliable_knobs = DOMAINOBJ[domain].backup(param_list)
                if avaliable_knobs is not None:
                    domain_result[domain] = avaliable_knobs
        return domain_result
    
    def post(self):
        """ Backup parameters value to backup file
        """
        param_domain_dict = json.loads(self.request.body)
        domain_result = self._backImpl(param_domain_dict)
        self.write(json.dumps(domain_result))
        self.finish()